/*------------------------------------------------------------------------------
 bin/djv_view/base.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "base.h"
#include <djv_ui/app.h>

void Color::lut_load()
{
  lut = image::Image();
  if (lut_file.get().size()) {
    File tmp = lut_file;
    if (tmp.seq_valid()) tmp.type = file::SEQ;
    try { lut = *image::io::load(tmp)->get(); }
    catch (Error error) {
      ui::app::app()->error(str::Format("%1: %2").
        arg(error).arg(File(lut_file).name()));
    }
  }
}

bool serialize(List<Str> * in, Color * out)
{
  if (! str::serialize(in, &out->name)) return false;
  if (! file::serialize(in, &out->lut_file)) return false;
  if (! image::gl::data::serialize(in, out)) return false;
  return true;
}

List<Str> serialize(const Color & in)
{
  return List<Str>() << str::serialize(in.name) <<
    file::serialize(in.lut_file) << image::gl::data::serialize(in);
}

const List<Str> & proxy_label()
{
  static const List<Str> data = List<Str>() << "None" << "1/2" << "1/4" <<
    "1/8";
  return data;
}

