/*------------------------------------------------------------------------------
 lib/djv_base/base.h
 
 Base

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_BASE_H
#define DJV_BASE_H

#include "config.h"
#include <djv_base/mem.h>
#include <djv_base/list.h>
#include <djv_base/str.h>
#include <djv_base/time.h>
#include <djv_base/dbg.h>
#include <djv_base/error.h>

namespace djv {

// Forward declarations.

namespace dbg { class Dbg; }
using dbg::Dbg;

namespace file { class File; }
using file::File;

namespace dir { class Dir; }
using dir::Dir;

namespace io { class Io; }
using io::Io;

namespace vec {
  template<typename T, int D> class Vec;
  template<typename T> class Vec2;
  template<typename T> class Vec3;
}
using vec::Vec;
using vec::Vec2;
using vec::Vec3;
typedef Vec2<int> Vec2i;
typedef Vec2<double> Vec2f;
typedef Vec3<int> Vec3i;
typedef Vec3<double> Vec3f;

namespace mtx {
  template<typename T> class Mtx3;
  template<typename T> class Mtx4;
}
using mtx::Mtx3;
using mtx::Mtx4;
typedef Mtx3<double> Mtx3f;
typedef Mtx4<double> Mtx4f;

namespace box {
  template<typename T, int D> class Box;
  template<typename T> class Box2;
  template<typename T> class Box3;
}
using box::Box;
using box::Box2;
using box::Box3;
typedef Box2<int> Box2i;
typedef Box2<double> Box2f;
typedef Box3<int> Box3i;
typedef Box3<double> Box3f;

}

#endif

