/*------------------------------------------------------------------------------
 lib/djv_base/list.h
 
 Lists
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_LIST_H
#define DJV_LIST_H

#include <djv_base/type.h>
#include <vector>

namespace djv {
namespace list {

template<typename T>
class List : public std::vector<T> {
public:

  // Functions.
  
  inline void push_front(const T &);
  inline T pop_front();
  inline T pop_back();

  inline void append(const T &);
  inline void append(const List<T> &);
  
  // Operators.

  inline List<T> & operator += (const T &);
  inline List<T> & operator += (const List<T> &);
  
  inline List<T> & operator << (const T &);
  inline List<T> & operator << (const List<T> &);
};

// Functions.

template<typename T>
inline int find(const T &, const List<T> &);

}
}

#include <djv_base/list_.h>

#endif

