/*------------------------------------------------------------------------------
 lib/djv_image/image.h
 
 Images
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_IMAGE_H
#define DJV_IMAGE_H

#include <djv_image/data.h>
#include <djv_image/gl_data.h>
#include <djv_image/tag.h>

namespace djv {
namespace image {

class Info : public data::Info {
public:

  Info() {}
  Info(const Vec2i & size, pixel::PIXEL pixel) :
    data::Info(size, pixel)
  {}
  
  tag::Tag tag;
  profile::Profile profile;
};

class Image : public Data {
public:

  Image();
  Image(const Info &, const uint8_t * = 0);
  
  void set(const Info &, const uint8_t * = 0);
  const Info & info() const { return _info; }
  
  void tag(const tag::Tag &);
  void profile(const profile::Profile &);
  
private:

  Info _info;
};

// Debugging.

Dbg & operator << (Dbg &, const Info &);
Dbg & operator << (Dbg &, const Image &);

}
}

#endif
