/*------------------------------------------------------------------------------
 lib/djv_ui/columns.h
 
 Columns Widget

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_COLUMNS_H
#define DJV_UI_COLUMNS_H

#include <djv_ui/widget.h>

namespace djv {
namespace ui {
namespace columns {

class Widget : public widget::Widget {
public:

  Widget();
  virtual ~Widget() {}
  
  // Value.
  
  void name_list(const List<Str> &);
  void size_list(const List<int> &);
  List<Str> name_list() const;
  List<int> size_list() const;
  Signal<const List<int> &> sig;
  Signal<int> action_sig;
  
  // Sorting.
  
  void sort(int);
  int  sort() const { return _sort; }
  void sort_reverse(bool);
  bool sort_reverse() const { return _sort_reverse; }
  
  // Widget.

  virtual int handle(int);
  virtual void draw();
  
  // Layout.

  virtual void dirty();
  virtual void resize(int, int, int, int);
  virtual Vec2i size_hint() const { return _size_hint; }
  
private:
  
  struct Column { Str name; int column; int size_hint; };

  static int handle_push(int, const List<Column> &);
  static int handle_drag(int, const List<Column> &);
  void columns_update();
  void widget_update();
  
  List<Column> _column_list;
  int _sort;
  bool _sort_reverse;
  
  Vec2i _size_hint;
  int _push, _drag;
};

}
}
}

#endif
