/*------------------------------------------------------------------------------
 lib/djv_ui/gl.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_ui/gl.cxx"

#include "gl.h"

namespace djv {
namespace ui {
namespace gl {

Widget::Widget() :
  Fl_Gl_Window(0, 0, 0, 0),
  _init(false),
  _size_hint(Vec2i(1, 1))
{
  end();
  
  mode(FL_RGB | FL_DOUBLE);
}

int Widget::handle(int in)
{
  switch (widget::Base::handle(in)) {
    case -1: return 0;
    case 1: return 1;
  }
  return Fl_Gl_Window::handle(in);
}

void Widget::draw()
{
  DJV_DBG_OBJ2(_DBG, "Widget::draw");
  
  if (! _init) {
    _init = true;
    GLint err = glewInit();
    if (err != GLEW_OK) {
      DJV_DBG_PRN("error glew init = " << Str((char *)glewGetErrorString(err)));
      return;
    }
  }
}

void Widget::resize(int x, int y, int w, int h)
{
  Fl_Gl_Window::resize(x, y, w, h);
  widget::Base::resize(x, y, w, h);
}

}
}
}
