/*------------------------------------------------------------------------------
 lib/djv_ui/icon.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "icon.h"
#include <FL/Fl_Pixmap.H>

#include "../../icon/file.xpm"
#include "../../icon/file_seq.xpm"
#include "../../icon/file_open.xpm"
#include "../../icon/file_reload.xpm"
#include "../../icon/file_close.xpm"

#include "../../icon/dir.xpm"
#include "../../icon/dir_up.xpm"
#include "../../icon/dir_prev.xpm"
#include "../../icon/dir_reload.xpm"

#include "../../icon/window_new.xpm"
#include "../../icon/window_copy.xpm"
#include "../../icon/window_close.xpm"
#include "../../icon/window_fit.xpm"
#include "../../icon/window_fullscreen.xpm"

#include "../../icon/view_left.xpm"
#include "../../icon/view_right.xpm"
#include "../../icon/view_up.xpm"
#include "../../icon/view_down.xpm"
#include "../../icon/view_zoom_in.xpm"
#include "../../icon/view_zoom_out.xpm"
#include "../../icon/view_zoom_reset.xpm"
#include "../../icon/view_fit.xpm"

#include "../../icon/shuttle_0.xpm"
#include "../../icon/shuttle_1.xpm"
#include "../../icon/shuttle_2.xpm"
#include "../../icon/shuttle_3.xpm"
#include "../../icon/shuttle_4.xpm"
#include "../../icon/shuttle_5.xpm"
#include "../../icon/shuttle_6.xpm"
#include "../../icon/shuttle_7.xpm"

#include "../../icon/playback_stop.xpm"
#include "../../icon/playback_forward.xpm"
#include "../../icon/playback_reverse.xpm"
#include "../../icon/playback_start.xpm"
#include "../../icon/playback_end.xpm"
#include "../../icon/playback_prev.xpm"
#include "../../icon/playback_next.xpm"

#include "../../icon/playback_shuttle_0.xpm"
#include "../../icon/playback_shuttle_1.xpm"
#include "../../icon/playback_shuttle_2.xpm"
#include "../../icon/playback_shuttle_3.xpm"
#include "../../icon/playback_shuttle_4.xpm"
#include "../../icon/playback_shuttle_5.xpm"
#include "../../icon/playback_shuttle_6.xpm"
#include "../../icon/playback_shuttle_7.xpm"

#include "../../icon/playback_frame_shuttle_0.xpm"
#include "../../icon/playback_frame_shuttle_1.xpm"
#include "../../icon/playback_frame_shuttle_2.xpm"
#include "../../icon/playback_frame_shuttle_3.xpm"
#include "../../icon/playback_frame_shuttle_4.xpm"
#include "../../icon/playback_frame_shuttle_5.xpm"
#include "../../icon/playback_frame_shuttle_6.xpm"
#include "../../icon/playback_frame_shuttle_7.xpm"

#include "../../icon/tool_start.xpm"
#include "../../icon/tool_end.xpm"
#include "../../icon/tool_x.xpm"
#include "../../icon/tool_lock.xpm"
#include "../../icon/tool_add.xpm"
#include "../../icon/tool_inc.xpm"
#include "../../icon/tool_dec.xpm"

#include "../../icon/image_color.xpm"
#include "../../icon/magnify.xpm"
#include "../../icon/color_sample.xpm"

namespace djv {
namespace ui {
namespace icon {

Factory::Factory() :
  _empty(0, 0, 0)
{
  add("file", new Fl_Pixmap((const char **)file_xpm));
  add("file_seq", new Fl_Pixmap((const char **)file_seq_xpm));
  add("file_open", new Fl_Pixmap((const char **)file_open_xpm));
  add("file_reload", new Fl_Pixmap((const char **)file_reload_xpm));
  add("file_close", new Fl_Pixmap((const char **)file_close_xpm));

  add("dir", new Fl_Pixmap((const char **)dir_xpm));
  add("dir_up", new Fl_Pixmap((const char **)dir_up_xpm));
  add("dir_prev", new Fl_Pixmap((const char **)dir_prev_xpm));
  add("dir_reload", new Fl_Pixmap((const char **)dir_reload_xpm));

  add("window_new", new Fl_Pixmap((const char **)window_new_xpm));
  add("window_copy", new Fl_Pixmap((const char **)window_copy_xpm));
  add("window_close", new Fl_Pixmap((const char **)window_close_xpm));
  add("window_fit", new Fl_Pixmap((const char **)window_fit_xpm));
  add("window_fullscreen", new Fl_Pixmap((const char **)window_fullscreen_xpm));
  
  add("view_left", new Fl_Pixmap((const char **)view_left_xpm));
  add("view_right", new Fl_Pixmap((const char **)view_right_xpm));
  add("view_up", new Fl_Pixmap((const char **)view_up_xpm));
  add("view_down", new Fl_Pixmap((const char **)view_down_xpm));
  add("view_zoom_in", new Fl_Pixmap((const char **)view_zoom_in_xpm));
  add("view_zoom_out", new Fl_Pixmap((const char **)view_zoom_out_xpm));
  add("view_zoom_reset", new Fl_Pixmap((const char **)view_zoom_reset_xpm));
  add("view_fit", new Fl_Pixmap((const char **)view_fit_xpm));
  
  add("shuttle_0", new Fl_Pixmap((const char **)shuttle_0_xpm));
  add("shuttle_1", new Fl_Pixmap((const char **)shuttle_1_xpm));
  add("shuttle_2", new Fl_Pixmap((const char **)shuttle_2_xpm));
  add("shuttle_3", new Fl_Pixmap((const char **)shuttle_3_xpm));
  add("shuttle_4", new Fl_Pixmap((const char **)shuttle_4_xpm));
  add("shuttle_5", new Fl_Pixmap((const char **)shuttle_5_xpm));
  add("shuttle_6", new Fl_Pixmap((const char **)shuttle_6_xpm));
  add("shuttle_7", new Fl_Pixmap((const char **)shuttle_7_xpm));
  
  add("playback_stop",
    new Fl_Pixmap((const char **)playback_stop_xpm));
  add("playback_forward",
    new Fl_Pixmap((const char **)playback_forward_xpm));
  add("playback_reverse",
    new Fl_Pixmap((const char **)playback_reverse_xpm));
  add("playback_start",
    new Fl_Pixmap((const char **)playback_start_xpm));
  add("playback_end",
    new Fl_Pixmap((const char **)playback_end_xpm));
  add("playback_prev",
    new Fl_Pixmap((const char **)playback_prev_xpm));
  add("playback_next",
    new Fl_Pixmap((const char **)playback_next_xpm));
  
  add("playback_shuttle_0",
    new Fl_Pixmap((const char **)playback_shuttle_0_xpm));
  add("playback_shuttle_1",
    new Fl_Pixmap((const char **)playback_shuttle_1_xpm));
  add("playback_shuttle_2",
    new Fl_Pixmap((const char **)playback_shuttle_2_xpm));
  add("playback_shuttle_3",
    new Fl_Pixmap((const char **)playback_shuttle_3_xpm));
  add("playback_shuttle_4",
    new Fl_Pixmap((const char **)playback_shuttle_4_xpm));
  add("playback_shuttle_5",
    new Fl_Pixmap((const char **)playback_shuttle_5_xpm));
  add("playback_shuttle_6",
    new Fl_Pixmap((const char **)playback_shuttle_6_xpm));
  add("playback_shuttle_7",
    new Fl_Pixmap((const char **)playback_shuttle_7_xpm));
  
  add("playback_frame_shuttle_0",
    new Fl_Pixmap((const char **)playback_frame_shuttle_0_xpm));
  add("playback_frame_shuttle_1",
    new Fl_Pixmap((const char **)playback_frame_shuttle_1_xpm));
  add("playback_frame_shuttle_2",
    new Fl_Pixmap((const char **)playback_frame_shuttle_2_xpm));
  add("playback_frame_shuttle_3",
    new Fl_Pixmap((const char **)playback_frame_shuttle_3_xpm));
  add("playback_frame_shuttle_4",
    new Fl_Pixmap((const char **)playback_frame_shuttle_4_xpm));
  add("playback_frame_shuttle_5",
    new Fl_Pixmap((const char **)playback_frame_shuttle_5_xpm));
  add("playback_frame_shuttle_6",
    new Fl_Pixmap((const char **)playback_frame_shuttle_6_xpm));
  add("playback_frame_shuttle_7",
    new Fl_Pixmap((const char **)playback_frame_shuttle_7_xpm));

  add("tool_start", new Fl_Pixmap((const char **)tool_start_xpm));
  add("tool_end", new Fl_Pixmap((const char **)tool_end_xpm));
  add("tool_x", new Fl_Pixmap((const char **)tool_x_xpm));
  add("tool_lock", new Fl_Pixmap((const char **)tool_lock_xpm));
  add("tool_add", new Fl_Pixmap((const char **)tool_add_xpm));
  add("tool_inc", new Fl_Pixmap((const char **)tool_inc_xpm));
  add("tool_dec", new Fl_Pixmap((const char **)tool_dec_xpm));

  add("image_color", new Fl_Pixmap((const char **)image_color_xpm));
  add("magnify", new Fl_Pixmap((const char **)magnify_xpm));
  add("color_sample", new Fl_Pixmap((const char **)color_sample_xpm));
}

Factory::~Factory()
{
  for (List::iterator i = _list.begin(); i != _list.end(); ++i)
    delete i->second;
}

void Factory::add(const Str & name, Fl_Image * icon)
{
  _list[name] = icon;
}

Fl_Image * Factory::get(const Str & name) const
{
  if (_list.find(name) == _list.end())
    return const_cast<Fl_Image *>(&_empty);
  return const_cast<Factory *>(this)->_list[name];
}

namespace { std::auto_ptr<Factory> _factory; }

Fl_Image * get(const Str & name)
{
  if (! _factory.get()) _factory = std::auto_ptr<Factory>(new Factory);
  return (*_factory).get(name);
}

void del() { _factory.reset(); }

}
}
}
