#define DJV_DBG

#include <djv_base/box.h>

using namespace djv;

int main(int argc, char ** argv)
{
  DJV_DBG_OBJ("box");
  
  Box2i box(0, 0);
  DJV_DBG_PRN("box = " << box);

  box = Box2i(51, 101, 100, 200);
  DJV_DBG_PRN("box = " << box);
  DJV_DBG_PRN("width = " << box.w);
  DJV_DBG_PRN("height = " << box.h);
  DJV_DBG_PRN("size = " << box.size);
  DJV_DBG_PRN("position1 = " << box.position1());
  
  DJV_ASSERT(box.x == 51);
  DJV_ASSERT(box.y == 101);
  DJV_ASSERT(box.w == 100);
  DJV_ASSERT(box.h == 200);
  DJV_ASSERT(size_valid(box));
  DJV_ASSERT(box.x1() == 150);
  DJV_ASSERT(box.y1() == 300);
  
  DJV_ASSERT(box == box);
  DJV_ASSERT(box != Box2i());
  
  box = Box2i(100, 150);
  DJV_DBG_PRN("box = " << box);
  DJV_ASSERT(box.w == 100);
  DJV_ASSERT(box.h == 150);
    
  return 0;
}
