//#define DJV_DBG

#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/label.h>
#include <djv_ui/app.h>

using namespace djv;

class App : public ui::app::App {
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  ui::app::App("text_label", argc, argv),
  _window(0)
{
  DJV_DBG_OBJ("App::App");
  
  ui::label::Text * label = new ui::label::Text(
    "one two three four five six seven eight nine ten\n"
    "\n"
    "ten nine eight seven six five four three two one");

  _window = new ui::window::Widget(name());

  ui::layout::Vertical * layout = new ui::layout::Vertical(_window);
  layout->add(label);
  
  _window->size(_window->size_hint());
  _window->show();

  _window->close_sig.set(this, exit_callback);

  valid(true);
}

App::~App()
{
  if (_window) _window->widget_del();
}

int main(int argc, char ** argv)
{
  return App(argc, argv).exec();
}
